<template>
	<v-sheet width="384" class="pb-14">
		<form @submit.prevent="onSubmit" class="pt-8">
			<div :class="{ error: v$.admin.name.$errors.length }">
				<label>Username</label>
				<span> *</span>
				<v-text-field
					base-color="#293148"
					color="#E4E4E4"
					class="mt-2"
					rounded="lg"
					variant="outlined"
					@blur="v$.admin.name.$touch"
					hide-details
					v-model="admin.name"
				>
				</v-text-field>
				<div v-for="error of v$.admin.name.$errors" :key="error.$uid">
					<small class="error-msg text-red">{{ error.$message }}</small>
				</div>
			</div>

			<div class="mt-6 mb-2" :class="{ error: v$.admin.email.$errors.length }">
				<label>Email address</label>
				<span> *</span>
				<v-text-field
					base-color="#293148"
					color="#E4E4E4"
					rounded="lg"
					class="mt-2"
					variant="outlined"
					hide-details
					@blur="v$.admin.email.$touch"
					v-model="admin.email"
				>
				</v-text-field>
				<div v-for="error of v$.admin.email.$errors" :key="error.$uid">
					<small class="error-msg text-red">{{ error.$message }}</small>
				</div>
			</div>
			<small class="input-email__explanation">This is your login</small>

			<div
				class="mt-6 mb-3"
				:class="{ error: v$.admin.password.$errors.length }"
			>
				<label>Password</label>
				<v-text-field
					base-color="#293148"
					color="#E4E4E4"
					rounded="lg"
					class="mt-2"
					variant="outlined"
					:type="showPassword ? 'text' : 'password'"
					:append-inner-icon="showPassword ? 'mdi-eye' : 'mdi-eye-off'"
					@click:append-inner="showPassword = !showPassword"
					hide-details
					autocomplete="on"
					@blur="v$.admin.password.$touch"
					v-model="admin.password"
				></v-text-field>
				<div v-for="error of v$.admin.password.$errors" :key="error.$uid">
					<small class="error-msg text-red">{{ error.$message }}</small>
				</div>
			</div>

			<div class="text-start">
				<v-btn
					class="btn__change-password text-capitalize px-0"
					flat
					@click="isOpen = !isOpen"
				>
					<p v-if="!isOpen">Change password</p>
					<p v-else>Cancel</p>
				</v-btn>
			</div>

			<Transition>
				<ChangePassword v-if="isOpen"></ChangePassword>
			</Transition>

			<div class="mt-3">
				<label>Contact phone</label>
				<v-text-field
					base-color="#293148"
					color="#E4E4E4"
					rounded="lg"
					class="mt-2"
					variant="outlined"
					hide-details
					v-model="admin.phone"
				></v-text-field>
			</div>

			<v-btn
				rounded="lg"
				class="mt-8"
				color="#D90E32"
				height="48"
				block
				type="submit"
			>
				save change
			</v-btn>
		</form>
	</v-sheet>
</template>

<script>
import { useVuelidate } from '@vuelidate/core'
import { required, email, minLength } from '@vuelidate/validators'
import ChangePassword from './ChangePassword.vue'
import { mapGetters } from 'vuex'

export default {
	name: 'CreateFormprofile',
	components: {
		ChangePassword,
	},
	props: {
		// adminInfo: {
		//   type: Object,
		//   default: () => {}
		// }
	},
	setup() {
		return { v$: useVuelidate() }
	},
	data() {
		return {
			admin: {
				name: '',
				email: '',
				password: '',
				phone: '',
			},

			isOpen: false,
			showPassword: false,
		}
	},
	validations() {
		return {
			admin: {
				name: { required },
				email: { required, email },
				password: { minLength: minLength(8) },
			},
		}
	},
	computed: {
		...mapGetters(['getAdminDetails']),
	},
	methods: {
		onSubmit() {
			if (this.v$.$invalid) {
				this.v$.$touch()
				return
			}

			console.log('Валидация успешно пройдена!')
			this.$emit('change', this.admin)
		},
	},
	created() {
		this.admin = { ...this.getAdminDetails }
	},
}
</script>

<style lang="scss">
label {
	color: rgba(41, 49, 72, 0.45);
	font-size: 15px;
	font-weight: 500;
	line-height: 20px;
}
.input-email__explanation {
	color: rgba(41, 49, 72, 0.8);
	font-size: 13px;
	font-weight: 400;
	line-height: 22px;
}
input {
	padding: 0;
	margin: 0;
}
.btn__change-password {
	color: #7895ff;
}
.v-enter-active,
.v-leave-active {
	transition: opacity 0.3s ease;
}

.v-enter-from,
.v-leave-to {
	opacity: 0;
}
</style>
